import javax.naming.Context;
import java.io.*;
import java.text.*;
import java.util.*;
import java.rmi.RemoteException;
import javax.management.ObjectName;

import weblogic.jndi.Environment;
import weblogic.management.MBeanHome;
import weblogic.management.WebLogicMBean;
import weblogic.management.WebLogicObjectName;
import weblogic.management.configuration.ServerMBean;
import weblogic.management.runtime.ServerRuntimeMBean;
import weblogic.management.runtime.ExecuteQueueRuntimeMBean;
import weblogic.management.runtime.JVMRuntimeMBean;
import weblogic.management.runtime.JDBCConnectionPoolRuntimeMBean;

public class serverExQInfo implements Runnable {

	String url = "t3://localhost";
	String serverName = "myserver";
	String username = "weblogic";
	String password = "weblogic";
	String adminPort = "7001";

	ExecuteQueueRuntimeMBean exQRuntime = null;
	JVMRuntimeMBean JVMRuntime = null;
	JDBCConnectionPoolRuntimeMBean JDBCConnPoolRuntime = null;
	ServerMBean aServer = null;
	Set mbeanSet = null;
	Iterator mbeanIterator = null;

	MBeanHome home = null;

	Environment env = null;

	Context ctx = null;

	Thread t = null;

	long timeStart = System.currentTimeMillis();
	long timeEnd = timeStart + 300000;
	long millisInterval = 60000;
	long millisToEnd = 300000;
	long startInqTime = 0;
	long endInqTime = 0;
	long diffInqTime = 0;
	long sleepTime = 0;

   SimpleDateFormat sdf = new SimpleDateFormat( "dd-MMM-yyyy HH:mm:ss" ); 
   FieldPosition fp = new FieldPosition( 1 ); 
   StringBuffer sdfBuf = new StringBuffer();
	Date obsDate = new Date();

	Date sDate = null;
	Date eDate = null; 

    
   String currOutFile = new String( "weblogic-monitor.xml" ); 
   boolean verboseStatus = false;
	boolean cmdlineStatus = true; 
    
    
   
   File webServerMonFile = new File( currOutFile ); 
   PrintWriter webServerMonPrint; 
   
	public serverExQInfo( String args[] ) {





		if ( !processCmdLine( args ) ) {
			cmdlineStatus = false;
       	System.exit( 0 );
		}

   try {
		webServerMonFile = new File( currOutFile );
		webServerMonPrint = 
			new PrintWriter( new FileOutputStream( webServerMonFile ), true );
	} catch ( FileNotFoundException fne ) {
		System.out.println( "Error on webServerMonFile: " + fne );
		System.exit( 100 );
	} 




		webServerMonPrint.println( "<?xml version=\"1.0\" ?>" );
		webServerMonPrint.println( " " );
		webServerMonPrint.println( "<!-- File Name: weblogic-monitor.xml -->" );
		webServerMonPrint.println( "<WEBLOGICMONITORSESSION>" );
		webServerMonPrint.println( "<STARTSTATE>" );
		webServerMonPrint.println( "<COMMANDLINE>" );
		StringBuffer wrkBuf = new StringBuffer();
		for(int i = 0; i < args.length; i++) {
				wrkBuf.append( args[i] + " " );
		}
		webServerMonPrint.println( wrkBuf.toString() );
		webServerMonPrint.println( "</COMMANDLINE>" );
		webServerMonPrint.println( "<URL>" );
		webServerMonPrint.println(  url  );
		webServerMonPrint.println( "</URL>" );
		webServerMonPrint.println( "<ADMINPORT>" );
		webServerMonPrint.println( adminPort );
		webServerMonPrint.println( "</ADMINPORT>" );
		webServerMonPrint.println( "<USERNAME>" );
		webServerMonPrint.println( username  );
		webServerMonPrint.println( "</USERNAME>" );
		webServerMonPrint.println( "<PASSWORD>" );
		webServerMonPrint.println( password );
		webServerMonPrint.println( "</PASSWORD>" );
		webServerMonPrint.println( "<START-DATE>" );
		webServerMonPrint.println( sDate.toString() );
		webServerMonPrint.println( "</START-DATE>" );
		webServerMonPrint.println( "<END-DATE>" );
		webServerMonPrint.println( eDate.toString() );
		webServerMonPrint.println( "</END-DATE>" );
		webServerMonPrint.println( "<INTERVAL-IN-MILLISECONDS>" );
		webServerMonPrint.println( millisInterval );
		webServerMonPrint.println( "</INTERVAL-IN-MILLISECONDS>" );
		webServerMonPrint.println( "</STARTSTATE>" );
		
		



		timeStart = System.currentTimeMillis();
		timeEnd = timeStart + millisToEnd;



 		try {
			// Obtaining an MBeanHome via JNDI
			env = new Environment();
			env.setProviderUrl( new String( url + ":" + adminPort ) );
			env.setSecurityPrincipal( username );
			env.setSecurityCredentials( password );
			ctx = env.getInitialContext();
			home = 
			(MBeanHome)ctx.lookup(MBeanHome.ADMIN_JNDI_NAME);
			if ( verboseStatus ) {
				System.out.println("Got the Admin MBeanHome: " + home);
				System.out.println("System Time: " + System.currentTimeMillis());
			}
		} catch (Exception e) {
				System.out.println("Exception caught: " + e );
		}


} // end serverExQInfo 

public void run() {
		
 		while ( System.currentTimeMillis() < eDate.getTime() ) {
			startInqTime = System.currentTimeMillis();
			if (verboseStatus) {
				System.out.println("Inquiry Actions Start:" +
					startInqTime + " Inquiry Actions End: " + eDate.getTime() +
						" Total Inquiry Time: " +
							 (eDate.getTime() - startInqTime) );
			}
			obsDate = new Date();
			fp = new FieldPosition(1);
			sdfBuf.setLength(0);
			sdf.format(obsDate, sdfBuf, fp);
			if ( verboseStatus ) {
				System.out.println("Observation Date/Time: " + sdfBuf );
			}
			webServerMonPrint.println( "<OBSERVATION>" );
			webServerMonPrint.println( "<TIMESTAMP>" );
			webServerMonPrint.println( sdfBuf );
			webServerMonPrint.println( "</TIMESTAMP>" );
			
			
			try {
					mbeanSet = home.getMBeansByType("ExecuteQueueRuntime");

					// Iterating thru results
			  		mbeanIterator = mbeanSet.iterator();
					while(mbeanIterator.hasNext()) {
						exQRuntime = (ExecuteQueueRuntimeMBean)mbeanIterator.next();
						if ( verboseStatus ) {
							System.out.println(" ExecuteQueueRuntimeMBean found: ");
							System.out.println("  Name: " + exQRuntime.getName());
							System.out.println("  Total Threads: " + 
												exQRuntime.getExecuteThreadTotalCount());
							System.out.println("  Idle Threads: " +
									exQRuntime.getExecuteThreadCurrentIdleCount());
							System.out.println("  Pending Requests: " + 
									exQRuntime.getPendingRequestCurrentCount());
						}
						
					  	webServerMonPrint.println("<ExecuteQueueRuntimeMBean>");
					  	webServerMonPrint.println("<Name>");
						webServerMonPrint.println( exQRuntime.getName() ); 
						webServerMonPrint.println("</Name>");
	 					webServerMonPrint.println("<Total-Threads>"); 
						webServerMonPrint.println(
								 exQRuntime.getExecuteThreadTotalCount() ); 
						webServerMonPrint.println("</Total-Threads>");
						webServerMonPrint.println("<Idle-Threads>");
						webServerMonPrint.println(
									exQRuntime.getExecuteThreadCurrentIdleCount() ); 
						webServerMonPrint.println("</Idle-Threads>");
						webServerMonPrint.println("<Pending-Requests>");
						webServerMonPrint.println( 
									exQRuntime.getPendingRequestCurrentCount() ); 
						webServerMonPrint.println("</Pending-Requests>");
						webServerMonPrint.println("</ExecuteQueueRuntimeMBean>");
						
					  
					}
			} catch (Exception e) {
					System.out.println("Exception caught: " + e );
			}

			try {
					mbeanSet = home.getMBeansByType("JVMRuntime");

					// Iterating thru results
			  		mbeanIterator = mbeanSet.iterator();
					while(mbeanIterator.hasNext()) {
						JVMRuntime = (JVMRuntimeMBean)mbeanIterator.next();
						if ( verboseStatus ) {
						System.out.println(" JVMRuntimeMBean found: ");
						System.out.println("  Current Heapsize in bytes: "
								 + JVMRuntime.getHeapSizeCurrent());
						System.out.println("  Current Free Heapsize in bytes: " + 
												JVMRuntime.getHeapFreeCurrent());
						}
						webServerMonPrint.println("<JVMRuntimeMBean>");
						webServerMonPrint.println("<Current-Heapsize>");
						webServerMonPrint.println(
								 JVMRuntime.getHeapSizeCurrent() );
						webServerMonPrint.println("</Current-Heapsize>");
						webServerMonPrint.println("<Current-Free-Heapsize>");
						webServerMonPrint.println(
										JVMRuntime.getHeapFreeCurrent() );
						webServerMonPrint.println("</Current-Free-Heapsize>");
						webServerMonPrint.println("</JVMRuntimeMBean>");
			}
			} catch (Exception e) {
					System.out.println("Exception caught: " + e );
			}

			try {
					mbeanSet = home.getMBeansByType("JDBCConnectionPoolRuntime");

					// Iterating thru results
			  		mbeanIterator = mbeanSet.iterator();
					while(mbeanIterator.hasNext()) {
						JDBCConnPoolRuntime =
						 (JDBCConnectionPoolRuntimeMBean)mbeanIterator.next();
						if ( verboseStatus ) {
						System.out.println(" JDBCConnectionPoolRuntimeMBean found: ");
						System.out.println("  Name: "
								 + JDBCConnPoolRuntime.getName());
						System.out.println("  ActiveConnectionsCurrentCount: " + 
					   JDBCConnPoolRuntime.getActiveConnectionsCurrentCount());
						System.out.println("  ConnectionsHighCount: " + 
					   JDBCConnPoolRuntime.getActiveConnectionsHighCount());
  						System.out.println("  LeakedConnectionCount: " + 
					   JDBCConnPoolRuntime.getLeakedConnectionCount());
  						System.out.println("  FailuresToReconnect: " + 
					   JDBCConnPoolRuntime.getFailuresToReconnectCount());
						}
					 	webServerMonPrint.println("<JDBCConnectionPoolRuntimeMBean>");
					 	webServerMonPrint.println("<Name>");
						webServerMonPrint.println(
								 JDBCConnPoolRuntime.getName() );
						webServerMonPrint.println("</Name>");
						webServerMonPrint.println("<ActiveConnectionsCurrentCount>");
						webServerMonPrint.println( 
					   JDBCConnPoolRuntime.getActiveConnectionsCurrentCount() );
						webServerMonPrint.println("</ActiveConnectionsCurrentCount>");
						webServerMonPrint.println("<ConnectionsHighCount>");
						webServerMonPrint.println( 
					   JDBCConnPoolRuntime.getActiveConnectionsHighCount() );
						webServerMonPrint.println("</ConnectionsHighCount>");
  						webServerMonPrint.println("<LeakedConnectionCount>");
						webServerMonPrint.println( 
					   JDBCConnPoolRuntime.getLeakedConnectionCount() );
  						webServerMonPrint.println("</LeakedConnectionCount>");
  						webServerMonPrint.println("<FailuresToReconnect>");
						webServerMonPrint.println(
					   JDBCConnPoolRuntime.getFailuresToReconnectCount() );
  						webServerMonPrint.println("</FailuresToReconnect>");
						webServerMonPrint.println("</JDBCConnectionPoolRuntimeMBean>");
			 	}            
			} catch (Exception e) {
					System.out.println("Exception caught: " + e );
			}

			try {
					mbeanSet = home.getMBeansByType("Server");

					// Iterating thru results
			  		mbeanIterator = mbeanSet.iterator();
					while(mbeanIterator.hasNext()) {
						aServer =
						 (ServerMBean)mbeanIterator.next();
						if ( verboseStatus ) {
							System.out.println(" ServerMBean found: ");
							System.out.println("  Name: "
								 + aServer.getName());
							System.out.println("  AcceptBacklog: " + 
					   		aServer.getAcceptBacklog());
						}
					  	webServerMonPrint.println("<ServerMBean>");
					  	webServerMonPrint.println("<Name>");
						webServerMonPrint.println(
								aServer.getName() );
						webServerMonPrint.println("</Name>");
					  	webServerMonPrint.println("<AcceptBacklog>");
						webServerMonPrint.println( 
					   		aServer.getAcceptBacklog() );
						webServerMonPrint.println("</AcceptBacklog>");
					  	webServerMonPrint.println("</ServerMBean>");
			}            
			} catch (Exception e) {
					System.out.println("Exception caught: " + e );
			}

      	endInqTime = System.currentTimeMillis();

			diffInqTime = endInqTime - startInqTime;
			if ( verboseStatus ) {
				System.out.println( "diffInqTime: " + diffInqTime );
			}
			
			try {
				t.sleep( millisInterval - diffInqTime );
			} catch (InterruptedException ie) {
					System.out.println("Exception caught: " + ie );
			}

			webServerMonPrint.println( "</OBSERVATION>" );

		}
		webServerMonPrint.println( "</WEBLOGICMONITORSESSION>" );
	} // end run()

	public static void main( String args[] ) {

		serverExQInfo ExQInf = new serverExQInfo( args );

		if (ExQInf.verboseStatus) {
			System.out.println("Command Line: ");
				for(int i = 0; i < args.length; i++) {
					System.out.println(args[i]);
				}
		}
		

		if (ExQInf.verboseStatus) {
			System.out.println("Thread startup at: " +
				System.currentTimeMillis() );
		}
				
		ExQInf.t = new Thread( ExQInf );

		if (ExQInf.verboseStatus) {
			if (ExQInf.sDate != null) {
				System.out.println("Current Time: " +
					System.currentTimeMillis() );
				System.out.println("Requested Start Time: " +
					ExQInf.sDate.toString() );
			}
			if (ExQInf.eDate != null) {
					System.out.println("Requested End Time: " +
					ExQInf.eDate.toString() );
			}
		}
		ExQInf.sleepTime = 0;
		if (ExQInf.sDate != null) {
			if (System.currentTimeMillis() < ExQInf.sDate.getTime()) {
				ExQInf.sleepTime =
				 ExQInf.sDate.getTime() - System.currentTimeMillis();
			}
		}
		try { 
				ExQInf.t.sleep( ExQInf.sleepTime );
		} catch(InterruptedException ie) {
				System.out.println("Exception caught: " + ie );
		}
	  	ExQInf.t.start();


	} // end main

public boolean processCmdLine( String args[] ) { 

	boolean bRtn = true; 
	int ii = 0;
 
	while( ii < args.length ) { 
                 
	if ( args[ ii ].startsWith( "-" ) ) { 
   	if ( args[ ii ].toUpperCase().endsWith( "VERSION" ) ) { 
      	bRtn = processVersionOpt(); 
		}	else if ( args[ ii ].toUpperCase().endsWith( "SERVER" ) ) {  
				ii++; 
				setServerName( args[ ii ] ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "VERBOSE" ) ) { 
				setVerbose( true ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "PORT" ) ) { 
				ii++; 
				setAdminPort( args[ ii ] ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "HELP" ) ) { 
				bRtn = processHelpOpt(); 
		} else if ( args[ ii ].toUpperCase().endsWith( "USER" ) ) {
				ii++; 
				setUserName( args[ ii ] ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "PASSWORD" ) ) {  
				ii++; 
				setPassword( args[ ii ] ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "OFILE" ) ) {  
				ii++; 
				setOutFile( args[ ii ] ); 
		} else if ( args[ ii ].toUpperCase().endsWith( "URL" ) ) {
				ii++; 
  				setServerURL( args[ ii ] ); 
 		} else if ( args[ ii ].toUpperCase().endsWith( "INTERVAL" ) ) {
				ii++; 
  				bRtn = setInterval( args[ ii ] ); 
 		} else if ( args[ ii ].toUpperCase().endsWith( "START" ) ) {
				ii++; 
  				bRtn = processStartOpt( args[ ii ] ); 
 		} else if ( args[ ii ].toUpperCase().endsWith( "END" ) ) {
				ii++; 
  				bRtn = processEndOpt( args[ ii ] ); 
 		} 
	}  
		ii++; 
	} 
         
	return( bRtn );
 
}

public boolean processVersionOpt() {

	System.out.println( "webMon version 0.0 - 9 Dec 2003" );

	return( false );
} 

public void setServerName( String srvNm ) {
 
   serverName = new String( srvNm );

}

public void setVerbose( boolean bVal ) {

	verboseStatus = bVal;

	if (verboseStatus) {
		System.out.println("Verbose Mode: ON");
	}

} 

public void setAdminPort( String aPort ) {

	adminPort = new String( aPort );

}

public void setServerURL( String urlVal ) {

	url = new String( urlVal );

} 

public void	setUserName( String uName ) {

	username = new String( uName );

} 

public void	setPassword( String pswd ) {

	password = new String( pswd );

} 

public void setOutFile( String ofile ) {

	currOutFile = new String( ofile );

} 


public boolean processHelpOpt() {

	System.out.println( " serverExQInfo Help" );
	System.out.println( " -verbose " );
	System.out.println( "   Turns on verbose mode, useful for debugging. " );
	System.out.println( " -version " );
	System.out.println( "   Returns program version and then terminates. " );
	System.out.println( " -start dd-mmm-yyyy HH:MM:ss ");
	System.out.println( "   When to start monitoring WebLogic Server. " );
	System.out.println( "   Default is program startup time. " );
	System.out.println( " -end dd-mmm-yyyy HH:MM:ss " );
	System.out.println( "   When to end monitoring WebLogic Server.   " );
	System.out.println( "   Default is 5 minutes from start. " );
	System.out.println( " -interval <seconds> " );
	System.out.println( "   Interval, in seconds, to query WebLogic Server." );
	System.out.println( "   Default is every 60 seconds. " );
	System.out.println( " -ofile <filename> " );
	System.out.println( "   Filename of output file.   " );
	System.out.println( "   Default is weblogic-monitor.xml in current " );
	System.out.println( "   directory. " );   
	System.out.println( " -url <URL for WebLogic Server> " );
	System.out.println( "   URL for WebLogic server.   " );
	System.out.println( "   Default is t3://localhost. " );
	System.out.println( " -server <WebLogic server name> " );
	System.out.println( "   WebLogic server name.   " );
	System.out.println( "   Default is myserver. " );
	System.out.println( " -url <URL for WebLogic Server> " );
	System.out.println( "   URL for WebLogic server.   " );
	System.out.println( "   Default is t3://localhost. " );
 	System.out.println( " -user <Name of WebLogic administrative user> " );
	System.out.println( "   Name of a WebLogic user with admin rights.   " );
	System.out.println( "   Default is weblogic. " );
	System.out.println( " -password <password for WebLogic admin user> " );
	System.out.println( "   Password for WebLogic admin user.   " );
	System.out.println( "   Yes, in clear text. " );
	System.out.println( "   Default is weblogic. " );





	return( false );

} 

public boolean setInterval( String sInt ) {
// Change from the input unit of a second to milliseconds
	boolean bRtn = true;

	try {

			millisInterval = new Long( sInt ).longValue();
			millisInterval = millisInterval * 1000;

	} catch( NumberFormatException nfe ) {
			bRtn = false;
	}	

	return( bRtn );

}
  
boolean processStartOpt( String strStartDate ) {
	// At some point, there will have to be a way for the program to
	// accept input that changes the incoming date/time string format
	// maybe via the .opt file?
	SimpleDateFormat sdf = new SimpleDateFormat( "dd-MMM-yyyy HH:mm:ss" );
	ParsePosition pp = new ParsePosition( 0 );
	StringBuffer wrkBuf = new StringBuffer();
	StringTokenizer st;

	System.out.println("processStartOpt: " + strStartDate);
	
	// Assumption is that the incoming date/time string is of the form
	// dd-MMM-yyyy HH:mm:ss.SS
	// But, very often the incoming date/time string comes in as 
	// d-MMM-yyyy HH:mm:ss  e.g. 5-Jun-2003 11:11:22
	// We check for this and prepend a '0'
	st = new StringTokenizer( strStartDate, "-", false );
	if ( st.nextToken().length() == 1 ) {
	    wrkBuf.append( '0' );
	    wrkBuf.append( strStartDate );
	} else {
	    wrkBuf.append( strStartDate );
	}

	System.out.println("processStartOpt: " + wrkBuf.toString() );
	sDate = sdf.parse( wrkBuf.toString(), pp );
	System.out.println("processStartOpt: " + sDate.toString() );
	

	return( true );
}
    
boolean processEndOpt( String strEndDate ) {
	// At some point, there will have to be a way for the program to
	// accept input that changes the incoming date/time string format
	// maybe via the .opt file?
	SimpleDateFormat sdf = new SimpleDateFormat( "dd-MMM-yyyy HH:mm:ss" );
	ParsePosition pp = new ParsePosition( 0 );                               
	StringBuffer wrkBuf = new StringBuffer();
	StringTokenizer st;

	
	// Assumption is that the incoming date/time string is of the form
	// dd-MMM-yyyy:HH:mm:ss.SS
	// But, very often the incoming date/time string comes in as 
	// d-MMM-yyyy HH:mm:ss  e.g. 5-Jun-2003 11:11:22
	// We check for this and prepend a '0'
	st = new StringTokenizer( strEndDate, "-", false );
	if ( st.nextToken().length() == 1 ) {
	    wrkBuf.append( '0' );
	    wrkBuf.append( strEndDate );
	} else {
	    wrkBuf.append( strEndDate );
	}

	eDate = sdf.parse( wrkBuf.toString(), pp );

	if (verboseStatus) {
		System.out.println("processEndOpt:pp after parse: " + pp.getIndex());
	}

	
	 
		
	return( true );
    
}

} // end class serverExQInfo
